Bug 579810 - Collection of Postgres table metrics fails when the tables are not in the public schema
Collection of Postgres table metrics fails when the tables are not in the pub...
Status: CLOSED CURRENTRELEASE
Product: RHQ Project
Classification: Other
Component: Plugins (Show other bugs)
1.3.1
All Linux
medium Severity medium (vote)
: ---
: RHQ 4.11
Assigned To: Thomas Segismont
Mike Foley
:
Depends On:
Blocks: 1095369
  Show dependency treegraph
 
Reported: 2010-04-06 11:51 EDT by lionel.duriez
Modified: 2014-07-21 06:13 EDT (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
: 1095369 (view as bug list)
Environment:
Last Closed: 2014-07-21 06:13:41 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)

  None (edit)
Description lionel.duriez 2010-04-06 11:51:41 EDT
The table metrics cannot be collected when the tables do not belong to the public schema.
The problem appears on the following environment :
Monitored Database : Postgresql 8.3
RHQ agent plugin version : rhq-postgres-plugin-1.3.1
Jopr Server version : 2.3.1

To reproduce the problem, create a new schema in a monitored database :
create schema myschema;

Then create a table in the new schema :
create table myschema.mytable (name varchar(20));

In Jopr, no metrics are available for the table mytable.
The role used by the agent to connect to the Postgresql DB is postgres.

The reason for the failure to collect the metrics can be found in the Postgresql logs :

ERROR:  relation "mytable" does not exist
STATEMENT:  SELECT ts.*,  pg_relation_size(ts.relname) AS table_size, pg_total_relation_size(ts.relname) AS total_size,
          ios.heap_blks_read, ios.heap_blks_hit, ios.idx_blks_read, ios.idx_blks_hit,
          ios.toast_blks_read, ios.toast_blks_hit, ios.tidx_blks_read, ios.tidx_blks_hit
        FROM pg_stat_user_tables ts LEFT JOIN pg_statio_user_tables ios on ts.relid = ios.relid
        WHERE ts.relname = $1

This is due to the fact that by default the search_path of a postgresql role is :
"$user",public

By default, the newly created schema is not looked in when performing a query.

To fix the problem, the select statement could me modified to look like this :

SELECT ts.*,
          pg_relation_size(ts.schemaname || '.' || ts.relname) AS table_size,
          pg_total_relation_size(ts.schemaname || '.' || ts.relname) AS total_size,
          ios.heap_blks_read, ios.heap_blks_hit, ios.idx_blks_read, ios.idx_blks_hit,
          ios.toast_blks_read, ios.toast_blks_hit, ios.tidx_blks_read, ios.tidx_blks_hit
        FROM pg_stat_user_tables ts LEFT JOIN pg_statio_user_tables ios on ts.relid = ios.relid
        WHERE ts.relname = 'mytable' and ts.schemaname='myschema';

As a temporary workaround, one could alter the search_path for the role postgres :

alter role postgres set search_path="$user",public,myschema;
Comment 1 Thomas Segismont 2014-04-08 05:59:11 EDT
Fixed in master

commit 835eca6a7b14bc92db5f98d336470f9b6ece145e
Author: Thomas Segismont <tsegismo@redhat.com>
Date:   Tue Apr 8 11:15:14 2014 +0200

Changed resource key format ("tablename"->"schemaname.tablename")
    
Implemented resource upgrade and updated resource component and discovery component
    
Also changed the availability check: new the resource component checks for table existence instead of looking at the parent database availability
Comment 2 Thomas Segismont 2014-04-09 11:47:26 EDT
The fix for this bug is a prerequisite of the fix for Bug 1079403
Comment 3 Heiko W. Rupp 2014-07-21 06:13:41 EDT
Bulk closing of RHQ 4.11 issues, now that RHQ 4.12 is out.

If you find an issue with those, please open a new BZ, linking to the old one.

Note You need to log in before you can comment on or make changes to this bug.